local myname="ZifnabsOutfitter"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={outfitter=Me} else ZifnabsMod.outfitter=Me end
local mod
local L
local C
local db
local PLAYERNAME=UnitName("player").." "..GetRealmName()
local slots={AMMO=0,HEAD=1,NECK=2,SHOULDER=3,SHIRT=4,CHEST=5,WAIST=6,LEGS=7,FEET=8,WRIST=9,HANDS=10,FINGER1=11,FINGER2=12,TRINKET1=13,TRINKET2=14,BACK=15,MAINHAND=16,OFFHAND=17,RANGED=18,TABARD=19,CLOAK=-1,HELM=-2}
local pos={AMMO={x=3,y=9},HEAD={x=0,y=1},NECK={x=0,y=2},SHOULDER={x=0,y=3},SHIRT={x=0,y=6},CHEST={x=0,y=5},WAIST={x=3,y=2},LEGS={x=3,y=3},FEET={x=3,y=4},WRIST={x=0,y=8},HANDS={x=3,y=1},FINGER1={x=3,y=5},FINGER2={x=3,y=6},TRINKET1={x=3,y=7},TRINKET2={x=3,y=8},BACK={x=0,y=4},MAINHAND={x=0,y=9},OFFHAND={x=1,y=9},RANGED={x=2,y=9},TABARD={x=0,y=7},CLOAK={x=0,y=10},HELM={x=0,y=10.4}}
local lastoutfit=nil
local outfitchangetime=0
local widget={}
local now=0
local config={}
local changed=false

-- TODO: Outfitwechsel im Kampf sperren

-- Slash Commands
SLASH_ZIFNABSOUTFITTER1 = "/zo"
SlashCmdList["ZIFNABSOUTFITTER"]=function (parm) Me:Command(parm) end

-- --------------------------------------------------------------------------------------
-- INITIALIZE
-- --------------------------------------------------------------------------------------
function Me:Initialize(fwinfo)
	mod=fwinfo.mod
	L=fwinfo.L
	C=fwinfo.C
	db=fwinfo.db
	if not db.outfitter then db.outfitter={outfit={},current={}} end
	if not db.outfitter.outfit[PLAYERNAME] then db.outfitter.outfit[PLAYERNAME]={NORMAL={camel="Normal"}} end
	widget.select=mod.ui:newControlButton(3,myname.."_Select",{click=Me.Click})
	mod.core:Register4Event("ONUPDATE","outfitter",Me.OnUpdate)
end

-- --------------------------------------------------------------------------------------
-- ON UPDATE
-- --------------------------------------------------------------------------------------
function Me:OnUpdate(elapsed)
	now=now+elapsed
	local outfitname=db.outfitter.current[PLAYERNAME] or "NORMAL"
	local outfit=db.outfitter.outfit[PLAYERNAME][outfitname]
	if outfit and outfit~=lastoutfit then
		widget.select:SetText(string.lower(string.sub(outfitname,1,1)))
		widget.select.tooltipText=L.word.outfit.." "..outfit.camel
		outfitchangetime=now
	elseif outfit and outfit==lastoutfit and now-outfitchangetime>0.5 then
		for slot,id in pairs(slots) do
			if id>=0 then
				local slotequip=GetInventoryItemID("player",id)
				local coutfit=outfit
				local coutfitname=outfitname
				if outfit[slot] and outfit[slot].ignore then
					coutfit=db.outfitter.outfit[PLAYERNAME].NORMAL
					coutfitname="NORMAL"
				end
				if not coutfit[slot] or (coutfit[slot].item~=slotequip) then
					if not coutfit[slot] then coutfit[slot]={item=slotequip}
					else coutfit[slot].item=slotequip end
					mod.f:PrintR(L.msg.outfitchanged,{outfit=coutfit.camel,slot=slot,item=Me:ItemName(slotequip) or L.word.nothing})
				end
			end
		end
	end
	lastoutfit=outfit
end

-- --------------------------------------------------------------------------------------
-- EXISTS IN BAG?
-- --------------------------------------------------------------------------------------
function Me:ExistsInBags(item)
	local found=false
	for bag=0,4,1 do
		for slot=1,40,1 do found=found or (GetContainerItemID(bag,slot)==item) end
	end
	return found
end

-- --------------------------------------------------------------------------------------
-- WEAR
-- --------------------------------------------------------------------------------------
function Me:Wear(outfitname)
	local uoutfitname=string.upper(outfitname)
	if db.outfitter.current[PLAYERNAME]==uoutfitname then nop=nil --nothing
	elseif mod.f:InFight() then mod.f:Print(L.msg.nochangeinfight,"buzzer.mp3")
	elseif mod.gatherer:IsFishing() then mod.f:Print(L.msg.nochangewhilefishing,"buzzer.mp3")
	else
		local outfit=db.outfitter.outfit[PLAYERNAME][uoutfitname] or {camel=outfitname}
		if not db.outfitter.outfit[PLAYERNAME][uoutfitname] then 
			for slot,nr in pairs(slots) do outfit[slot]={ignore=true} end
			db.outfitter.outfit[PLAYERNAME][uoutfitname]=outfit 
		end
		local freeslots={[0]=0,[1]=0,[2]=0,[3]=0,[4]=0}
		for bag=0,4,1 do
			for slot=1,GetContainerNumSlots(bag),1 do 
				if not GetContainerItemID(bag,slot) then freeslots[bag]=freeslots[bag]+1 end
			end
		end
		for slot,id in pairs(slots) do
			local slotequip=GetInventoryItemID("player",id)
			if not outfit[slot] then outfit[slot]={} end
			local shallequip=outfit[slot].item
			if outfit[slot].ignore then shallequip=db.outfitter.outfit[PLAYERNAME]["NORMAL"][slot].item end
			local itemname=Me:ItemName(shallequip)			
			if id>=0 and shallequip~=slotequip then
				if slotequip and not shallequip then
					local usebag=nil
					for bag=4,0,-1 do
						if freeslots[bag]>0 and not usebag then
							usebag=bag
							freeslots[bag]=freeslots[bag]-1
						end
					end
					if not usebag then mod.f:PrintR(L.msg.noroomfor,{outfit=outfit.camel,slot=slot})
					else
						if usebag==0 then
mod.f:PrintR(L.msg.noroomfor,{outfit=outfit.camel,slot=slot})						
--							PickupInventoryItem(id)
--							PutItemInBagpack()
						else
							PickupInventoryItem(id)
							PutItemInBag(usebag+19)
						end
					end
				elseif Me:ExistsInBags(shallequip)==true then
					EquipItemByName(itemname,id)
				else 
					if itemname then mod.f:PrintR(L.msg.itemnotfound,{outfit=outfit.camel,slot=slot,item=itemname}) end
				end
			end
		end
		if outfit["HELM"] and outfit["HELM"].ignore then ShowHelm(false) else ShowHelm(true) end
		if outfit["CLOAK"] and outfit["CLOAK"].ignore then ShowCloak(false) else ShowCloak(true) end
		if uoutfitname~=db.outfitter.current[PLAYERNAME] then mod.f:PrintR(L.msg.nowwearing,{outfit=outfit.camel}) end
		db.outfitter.current[PLAYERNAME]=uoutfitname
	end
end

-- --------------------------------------------------------------------------------------
-- IGNORE
-- --------------------------------------------------------------------------------------
function Me:Ignore(outfitname,slot,truefalse)
	local outfit=db.outfitter.outfit[PLAYERNAME][outfitname]
	if not outfit then mod.f:PrintR(L.msg.unknownoutfit,{outfit=outfitname})
	else
		for oneslot,slotnr in pairs(slots) do
			if not outfit[oneslot] then outfit[oneslot]={} end
			if slot=="ALL" or oneslot==slot then 
				outfit[oneslot].ignore=truefalse
				Me:List(outfitname,oneslot)
			end
		end
	end
end

-- --------------------------------------------------------------------------------------
-- LIST
-- --------------------------------------------------------------------------------------
function Me:List(outfitname,slot)
	local outfit=db.outfitter.outfit[PLAYERNAME][outfitname]
	if not outfit then mod.f:PrintR(L.msg.unknownoutfit,{outfit=outfitname})
	else
		for oneslot,slotnr in pairs(slots) do
			if not outfit[oneslot] then outfit[oneslot]={} end
			local use="+"
			if outfit[oneslot].ignore then use="-" end
			if slotnr>=0 and (slot=="ALL" or oneslot==slot) then
				mod.f:PrintR("<outfit> <use> <slot>: <item>",{use=use,outfit=outfit.camel,slot=oneslot,item=Me:ItemName(outfit[oneslot].item) or L.word.nothing,ignore=ignore})
			end
		end
		if slot=="ALL" or slot=="HELM" then 
			if outfit["HELM"].ignore==true then mod.f:PrintR(L.msg.showhelm,{pm="-"}) else mod.f:PrintR(L.msg.showhelm,{pm="+"}) end 
		end
		if slot=="ALL" or slot=="CLOAK" then 
			if outfit["CLOAK"].ignore==true then mod.f:PrintR(L.msg.showcloak,{pm="-"}) else mod.f:PrintR(L.msg.showcloak,{pm="+"}) end 
		end
	end
end

-- --------------------------------------------------------------------------------------
-- ITEM NAME
-- --------------------------------------------------------------------------------------
function Me:ItemName(itemid)
	if not itemid then return nil end
	local itemname=GetItemInfo(itemid)
	return itemname
end

-- --------------------------------------------------------------------------------------
-- COMMAND
-- --------------------------------------------------------------------------------------
function Me:Command(cmd)
	local parse=mod.f:Split(cmd," ")
	local cmd=string.upper(parse[1] or "")
	local slot=string.upper(parse[2] or "ALL")
	local outfit=parse[3] or db.outfitter.current[PLAYERNAME] or "Normal"
	if cmd=="WEAR" then Me:Wear(parse[2] or "Normal")
	elseif cmd=="LIST" then Me:List(string.upper(outfit),slot)
	elseif cmd=="IGNORE" then Me:Ignore(string.upper(outfit),slot,true)
	elseif cmd=="UNIGNORE" then Me:Ignore(string.upper(outfit),slot,false)
	elseif (cmd=="SHOW" or cmd=="HIDE") and slot=="CLOAK" then
		Me:Ignore(string.upper(outfit),"CLOAK",(cmd=="HIDE"))
		ShowCloak(cmd=="SHOW")
	elseif (cmd=="SHOW" or cmd=="HIDE") and slot=="HELM" then
		Me:Ignore(string.upper(outfit),"HELM",(cmd=="HIDE"))
		ShowHelm(cmd=="SHOW")
	else mod.f:PrintR(L.msg.unknowncmd,{cmd=cmd}) end
end

-- --------------------------------------------------------------------------------------
-- INPUT NEW
-- --------------------------------------------------------------------------------------
function Me:InputNew(keywidget,key)
	if key=="ESCAPE" then Me:Click(widget.config.delete)
	elseif key=="ENTER" then Me:Click(widget.config.new)
	end
end
-- --------------------------------------------------------------------------------------
-- CLICK
-- --------------------------------------------------------------------------------------
function Me:Click(button,parse)
	if button.action=="new" then
		if changed then mod.f:Print(L.msg.unsavedchanges,"Buzzer.mp3")
		else
			widget.config.new:SetText(L.word.store)
			widget.config.delete:SetText(L.word.abort)
			widget.config.new.action="store"
			widget.config.delete.action="abort"
			widget.config.editbox:SetText("")
			widget.config.editbox:Show()
			widget.config.outfitname:Hide()
		end
	elseif button.action=="store" or button.action=="abort" then
		if button.action=="store" then
			local outfitname=mod.f:Trim(widget.config.editbox:GetText())
			if outfitname=="" then
				mod.f:Print(L.msg.noname,"Buzzer.mp3")
				return
			end
			local uoutfitname=string.upper(outfitname)
			db.outfitter.outfit[PLAYERNAME][uoutfitname]={camel=outfitname}
			for slot,nr in pairs(slots) do 
				db.outfitter.outfit[PLAYERNAME][uoutfitname][slot]={ignore=true} 
			end
			config.outfit[1+#config.outfit]=uoutfitname
			Me:ConfigSelectOutfit(#config.outfit)
		end
		widget.config.new:SetText(L.word.new)
		widget.config.delete:SetText(L.word.delete)
		widget.config.new.action="new"
		widget.config.delete.action="delete"
		widget.config.editbox:Hide()
		widget.config.outfitname:Show()
	elseif button.action=="delete" then
		if config.outfit[config.nr]=="NORMAL" then
			mod.f:Print(L.msg.normalundeletable,"Buzzer.mp3")
			return
		elseif config.outfit[config.nr]==db.outfitter.current[PLAYERNAME] then
			mod.f:Print(L.msg.deletedcurrent,"dingding.mp3")
			Me:Wear("NORMAL")
		end
		local copy={db={},config={outfit={},nr=1}}
		for uoutfit,data in pairs(db.outfitter.outfit[PLAYERNAME]) do
			if uoutfit~=config.outfit[config.nr] then 
				copy.db[uoutfit]=data
				copy.config.outfit[1+#copy.config.outfit]=uoutfit
				if uoutfit=="NORMAL" then copy.config.nr=#copy.config.outfit end
			end
		end
		mod.f:PrintR(L.msg.deletedoutfit,{outfit=config.outfit[config.nr]})
		config=copy.config
		db.outfitter.outfit[PLAYERNAME]=copy.db
		Me:ConfigSelectOutfit(#config.outfit)
	elseif button.action then
		if changed then mod.f:Print(L.msg.unsavedchanges,"Buzzer.mp3")
		else	
			config.nr=config.nr+button.action
			if config.nr<1 then config.nr=config.nr+#config.outfit end
			if config.nr>#config.outfit then config.nr=config.nr-#config.outfit end
			Me:ConfigSelectOutfit(config.nr)
		end
	else
		if button.outfit then Me:Wear(button.outfit) end
		if button.outfit or parse[#parse]=="Select" then
			if not widget.list then widget.list={} end
			widget.select.showing=not widget.select.showing
			if not widget.select.showing then
				for n,btn in pairs(widget.list) do btn:Hide() end
			else
				local nr=0
				for uoutfitname,outfit in pairs(db.outfitter.outfit[PLAYERNAME]) do
					if not widget.list[nr] then
						widget.list[nr]=mod.ui:newButton(myname,80,16,widget.select,"TOPLEFT","TOPRIGHT",0,-16*nr,{click=Me.Click})
					end
					widget.list[nr].outfit=outfit.camel
					widget.list[nr]:SetText(outfit.camel)
					widget.list[nr]:Show()
					nr=nr+1
				end
			end
		end
	end
end

-- --------------------------------------------------------------------------------------
-- START CONFIG
-- --------------------------------------------------------------------------------------
function Me:StartConfig(frame)
	config={outfit={},nr=1}
	for uoutfit,data in pairs(db.outfitter.outfit[PLAYERNAME]) do
		config.outfit[1+#config.outfit]=uoutfit
		if uoutfit==db.outfitter.current[PLAYERNAME] then config.nr=#config.outfit end
	end
	if not widget.config then
		widget.config={icon={}}
		widget.config.outfitname=mod.ui:addText(myname.."_Outfit",600,20,frame,"TOP","TOP",0,0,12,"CENTER","CENTER")
		widget.config.back=mod.ui:newButton(myname.."_Left",16,16,frame,"TOPLEFT","TOPLEFT",4,-4,{text="<",click=Me.Click})
		widget.config.back.action=-1
		widget.config.fore=mod.ui:newButton(myname.."_Right",16,16,frame,"TOPRIGHT","TOPRIGHT",-4,-4,{text=">",click=Me.Click})
		widget.config.fore.action=1
		widget.config.new=mod.ui:newButton(myname.."_New",60,16,frame,"TOPLEFT","TOPLEFT",20,-4,{text=L.word.new,click=Me.Click})
		widget.config.new.action="new"
		widget.config.delete=mod.ui:newButton(myname.."_New",60,16,frame,"TOPRIGHT","TOPRIGHT",-20,-4,{text=L.word.delete,click=Me.Click})
		widget.config.delete.action="delete"
		widget.config.editbox=mod.ui:newEditBox(myname.."_New_Input",150,20,frame,"TOPLEFT","TOPLEFT",225,-4,{onkey=Me.InputNew,hide=true})
		for slot,nr in pairs(slots) do
			widget.config[slot]=mod.ui:newCheck(myname.."_"..slot,20,20,frame,"TOPLEFT","TOPLEFT",40+150*pos[slot].x,-40*pos[slot].y,{text=L.word[slot],click=Me.ConfigChange})
			widget.config[slot].slot=slot
			if nr>=0 then 
				widget.config.icon[slot]=mod.ui:newButton(myname.."_Icon_"..slot,35,35,widget.config[slot],"TOPLEFT","TOPRIGHT",0,0,{inherit="Zifnabs_Icon"})
			end
		end
	end
	Me:ConfigSelectOutfit(config.nr)
end

-- --------------------------------------------------------------------------------------
-- CONFIG CHECK FOR CHANGES
-- --------------------------------------------------------------------------------------
function Me:ConfigChange(button,parse)
	local uoutfit=config.outfit[config.nr]
	changed=false
	for slot,nr in pairs(slots) do
		changed=changed or (widget.config[slot]:GetChecked()==(db.outfitter.outfit[PLAYERNAME][uoutfit][slot].ignore or false))
	end
	mod.core:SetUnsavedChanges(changed)
end

-- --------------------------------------------------------------------------------------
-- CONFIG SHOW OUTFIT
-- --------------------------------------------------------------------------------------
function Me:ConfigSelectOutfit(nr)
	config.nr=nr
	local uoutfit=config.outfit[nr]
	local outfit=db.outfitter.outfit[PLAYERNAME][uoutfit]
	local enable=(uoutfit~="NORMAL")
	widget.config.outfitname:SetText(outfit.camel)
	config.item={}
	for slot,nr in pairs(slots) do
		if not outfit[slot] then outfit[slot]={} end
		widget.config[slot]:SetChecked(not outfit[slot] or not outfit[slot].ignore)
		if nr>=0 then
			if enable then widget.config[slot]:Enable() else widget.config[slot]:Disable() end
			local shallequip=outfit[slot].item
			config.item[slot]=shallequip
			if outfit[slot].ignore then shallequip=db.outfitter.outfit[PLAYERNAME]["NORMAL"][slot].item end
			if not shallequip then
				widget.config.icon[slot]:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = nil});
				widget.config.icon[slot]:SetNormalTexture(nil)
				widget.config.icon[slot]:SetBackdropColor(0.9,0.5,0.5,1)
				widget.config.icon[slot].tt=L.word.nothing
				widget.config.icon[slot]:SetAlpha(1)
			else
				local itemname,ilink,irare,ilevel,iminlvl, itype,isubtype, iscount, iequiploc, itemtexture, iprice=GetItemInfo(shallequip)
				widget.config.icon[slot]:SetBackdrop(nil)
				widget.config.icon[slot]:SetNormalTexture(itemtexture)
				widget.config.icon[slot].tt=iconname
			end
		end
	end
end

-- --------------------------------------------------------------------------------------
-- SAVE CONFIG
-- --------------------------------------------------------------------------------------
function Me:SaveConfig(frame)
	local uoutfit=config.outfit[config.nr]
	for slot,nr in pairs(slots) do
		if widget.config[slot]:GetChecked() then
			db.outfitter.outfit[PLAYERNAME][uoutfit][slot]={item=config.item[slot]}
		else
			db.outfitter.outfit[PLAYERNAME][uoutfit][slot]={ignore=true}
		end
	end
	changed=false
	return true
end

-- --------------------------------------------------------------------------------------
-- IGNORE CONFIG
-- --------------------------------------------------------------------------------------
function Me:IgnoreConfig(frame) 
	changed=false
	return true 
end
